10 REM TERMINAL PROGRAM FOR BBC COMPUTER
20 REM (C) 1982 BY ANDREW D. HOLT
21 REM AND R&EW
28 REM ECHO% indicates whether characters sent are to be echoed
30 ECHO%=FALSE
40 CHFLAG=FALSE
48 REM let print receive line feeds
50 *FX 6,0
54 REM
55 REM set up some useful function keys
56 REM "0" for 'break'
60 *KEY 0 wHIA"
70 *KEY 10 "OLDIM*FX 6,0IMLISTIM"
75 REM "1" to start printer
80 *KEY 1 "1[18"
85 REM "2" to stop printer
90 *KEY 2 "MC"
95 REM "3" to send 'escape'
100 *KEY 3 "Ulf"
110 *KEY 9 "RUNIM"
115 REM compile assembler routines
120 PROCCOMPILE
125 REM 25 lines of 80 columns
130 MODE 3
135REM switch off Escape (o/s version 0.1 only)
140REM?&226=&FF@z
145 REM set colours (black on cyan) for best readability
150 VDU19,1,0,0,0,0,19,0,6,0,0,0,12
152 REM mode% is used to set transmission mode -
153 REM 2 = 7 bit even parity 2 stop bits
154 REM 10 = 7 bit even parity 1 stop bit
155 REM 18 = 8 bit no parity 2 stop bits
156 REM 22 = 8 bit no parity 1 stop bit
160 mode%=10
165 REM reset acia
170 ?&FE08=3:?&FE08=mode%
175 REM set speeds (300 baud)
180 *FX 8,3
190 *FX 7,3
195 REM main loop starts here
200 STA%=?&FE08:IF 1 AND STA% THEN 270
220 CH=INKEY(0)
230 IF CH= -1 THEN 200
240 PROCSENDCH(CH)
250 GOTO 200
260 REM CGET is an assembler routine to get a character
262 REM and display it if it is 'safe'
270 CALL CGET
280 GOTO 200
375 REM this is a procedure to send a 'break'
380 DEF PROCSENDBK
390 LOCAL X
400 X=TIME
410 7&FE08=mode% OR &60
420 REPEAT UNTIL TIME > X+5
430 ?&FE08=mode%
440 ENDPROC
445 REM procedure to decide what to do with keyboard character
450 DEF PROCSENDCH(CH)
460 IF CHFLAG THEN PROCESCAPED(CH):ENDPROC
465 REM 'Escape' is used as a flag
470 CHFLAG = CH=&1B:IF CHFLAG THEN ENDPROC
480 A%=CH:CALL CPUT%
490 IF ECHO% THEN PRINT CHR$(CH);
500 ENDPROC
505 REM Esc Ctrl A for 'Break'
506 REM Esc CTr1 B(C) for printer on(off)
510 DEF PROCESCAPED (CH)
520 CHFLAG=FALSE
530 IF CH=1 THEN PROCSENDBK:ENDPROC
540 IF CH=2 OR CH=3 THEN VDU CH:ENDPROC
550 ?&FE09=CH
560 ENDPROC
570 DEFPROCCOMPILE
580 DIM CPUT%100:P%=CPUT%:[OPT 2:STA &FE09:RTS:]
590 ITC=P%:PTC=P%
600 CGET=P%:OSWRCH=&FFEE
610 FOR X%=0 TO 1
620   P%=CGET
630   [OPT 2:LDA &FE09:AND #&7F:BEQ ITC
640   CMP#&7F:BEQ ITC:CMP #&1F:BPL PTC
650   CMP #14:BPL ITC:CMP #7:BMI ITC
660   .PTC JSR OSWRCH:.ITC RTS:]
670   NEXT X%
680 ENDPROC
